// Twirl (Marek Konopka - Konop/Shadows, Tebe/Madteam)

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, StdCtrls, ExtCtrls, Math;

type
  TForm1 = class(TForm)
    Start: TButton;
    Image1: TImage;
    cbTwirl: TCheckBox;
    procedure StartClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
 texture_size_x = 64;
 texture_size_y = 64;

 picture_size_x = 64;
 picture_size_y = 64;

 circle_steps = 256;
 max_radiuses = 48;

var
 Form1: TForm1;

 angles, radiuses: array [0..picture_size_x-1, 0..picture_size_x-1] of byte;
 aborted: Boolean;

 speed: array [0..max_radiuses-1] of word;
 addition: array [0..511] of word;

 input_texture, output_texture: TBitmap;


implementation

{$R *.dfm}


procedure calc_tables;
// Obliczenie tablic ANGLES, RADIUSES
var max_radius, radius, angle: double;
    x, y, x_screen, y_screen, angle_int, radius_int: integer;
begin

  max_radius := sqrt( sqr(picture_size_x div 2) + sqr(picture_size_y div 2) );

  for y:=0 to picture_size_y-1 do begin

    y_screen := -(y - (picture_size_y div 2));

    for x:=0 to picture_size_x-1 do begin

      x_screen := x - (picture_size_x div 2);

      angle := ArcTan2(y_screen, x_screen);

      angle := angle / (2.0 * pi);                         // normalize
      angle_int := round(angle * circle_steps);

      radius := sqrt(x_screen * x_screen + y_screen * y_screen);
      radius := radius / (max_radius * sqrt(2));           // normalize
      radius_int := round(radius * (max_radiuses-1));

      angles[x, y] := angle_int;
      radiuses[x, y] := radius_int;

    end;

  end;

end;


procedure calc_texture;
// Obliczenie tablicy z tekstura TEXTURE_OUTPUT
// kazda pozioma linia tej tablicy to piksle nalezace do konkretnego promienia okregu
var angle, x, y: double;
    r, a, x_int, y_int: integer;
begin

 for r:=0 to max_radiuses-1 do
  for a:=0 to circle_steps-1 do begin

    angle := a / circle_steps;
    angle := angle * 2.0 * pi;

    x := cos(angle) * r;
    y := sin(angle) * r;

    x_int := round(x) + texture_size_x div 2;
    y_int := round(y) + texture_size_y div 2;

    output_texture.Canvas.Pixels[a,r] := input_texture.Canvas.Pixels[x_int, y_int];

  end;

end;


procedure calc_addition;
var i: integer;
begin

 for i := 0 to 511 do addition[i] := round(sin(i*(360/256)*pi/180)*1024);

end;    


procedure TForm1.StartClick(Sender: TObject);
var x, y: integer;
    anm, rad, add: byte;
    bmp: TBitmap;
    c: TColor;
begin

 bmp:=TBitmap.Create;
 bmp.PixelFormat:=pf24bit;
 bmp.Width  := picture_size_x;
 bmp.Height := picture_size_y;

 input_texture:=TBitmap.Create;
 input_texture.LoadFromFile('t64_15.bmp');
 input_texture.PixelFormat:=pf24bit;
 input_texture.Width  := texture_size_x;
 input_texture.Height := texture_size_y;

 output_texture:=TBitmap.Create;
 output_texture.PixelFormat:=pf24bit;
 output_texture.Width  := circle_steps;
 output_texture.Height := max_radiuses;

// policzenie tablic
 calc_tables;
 calc_texture;
 calc_addition;

// glowna petla
 anm:=0;
 aborted:=false;      

 repeat

  sleep(5);

  Application.ProcessMessages;
  if Aborted then Break;

  for y:=0 to picture_size_y do
   for x:=0 to picture_size_x do begin

    rad := Radiuses[x,y];

    if cbTwirl.Checked then
     add:=speed[rad]  shr 8
    else
     add:=anm;

    c := output_Texture.Canvas.Pixels [ byte(Angles[x,y] + add) {mod circle_steps} , rad ];

    bmp.Canvas.Pixels[x,y] := c;
   end;

  for x := 0 to max_radiuses-1 do speed[x]:=word(speed[x] + addition[x+x+anm]);

  inc(byte(anm));

  form1.image1.Picture.Graphic:=bmp;

 until false;

 bmp.Free;
 input_texture.Free;
 output_texture.Free;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
 doublebuffered:=true;
end;


procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key=#27 then Aborted:=true;
end;

end.

